#!/usr/local/bin/perl
#
# MasterWebpageMailer Version 1.0
# August 2, 1999
# Author: William Bontrager
# Author's E-mail: william@willmaster.com
# Author's Website: http://www.willmaster.com/
#
# MasterWebpageMailer is designed to email the contents of your web page (the 
# portions you specify) to your visitor or visitor's associate.
#
# It is designed to be executed with Perl 5; it won't work with versions prior to 5.
# It was developed and tested on a Unix server.
#
# COPYRIGHT NOTICE
# Copyright (c) 1998, 1999 by William Bontrager. All rights reserved.
#
# MasterWebpageMailer may be used and modified free of charge by anyone so long as
# this header information and copyright notice remain intact. By using and/or
# modifying MasterWebpageMailer you agree to indemnify William Bontrager and his
# associates from any liability that might arise from its use and/or modification.
#
# Selling the code for MasterWebpageMailer without prior written consent from the
# copyright owner is expressly forbidden. You must have permission before
# redistributing MasterWebpageMailer. In all cases, this header information and
# copyright notice must remain intact and the README file must be readily 
# available.
#
#	-------	End: header information and copyright notice	-------
#
#===============================

$ConfigFile = 'globals.cgi';
if(open(R,"$ConfigFile"))
{
	my @mem = <R>;
	close R;
	for (@mem)
	{
		next if $_ =~ /\A\#/;
		next unless $_ =~ /\=/;
		my ($n,$v) = split(/=/,$_);
		$n = &StripAllWhiteSpace($n);
		$v = &StripWhiteSpaceFrontAndBack($v);
		$v = &ReplaceConsecutiveWhiteSpace($v);
		$G{$n} = $v;
	}
	$G{ToAddy} =~ s/\*/\@/;
}
else { &ErrorHTML("Sorry. Couldn't open a critical file, $ConfigFile"); }
&ParseFormData;
if(! &ValidEmail($In{fromemail})) { &ErrorHTML("The email address $In{fromemail} appears to be invalid."); }
if(! &ValidEmail($In{toemail})) { &ErrorHTML("The email address $In{toemail} appears to be invalid."); }
if($In{name} =~ /\@/) { &ErrorHTML("The name, \"$In{name}\", appears to be incorrect. Maybe you typed an email address by mistake?"); }
if($In{name} !~ /\w/) { &ErrorHTML("A name must be provided."); }
$In{name} = &StripWhiteSpaceFrontAndBack($In{name});
if(! open(R,"$In{path}")) { &ErrorHTML("Sorry. Can't read the web page $In{path}"); }
@L = <R>;
close R;
open(MAIL,"|$G{MailProgram}");
print MAIL "To: $In{toemail}\n";
print MAIL "From: \"$In{name}\" \<$In{fromemail}\>\n";
print MAIL "Subject: Contents of $ENV{HTTP_REFERER}\n\n";
$printline = 0;
for(@L)
{
	if($_ =~ /BEGIN MasterWebpageMailer/) { $printline = 1; next; }
	next unless $printline;
	if($_ =~ /END MasterWebpageMailer/) { $printline = 0; next; }
	$_ =~ s/\<.*?\>//g;
	$_ =~ s/\&lt\;/\</g;
	$_ =~ s/\&gt\;/\>/g;
	$_ =~ s/\&quot\;/\"/g;
	$_ =~ s/\&nbsp\;/ /g;
	print MAIL $_;
}
close MAIL;
sleep 2;
open(MAIL,"|$G{MailProgram}");
print MAIL "To: $G{ToAddy}\n";
print MAIL "From: $G{ToAddy}\n";
print MAIL "Subject: MasterWebpageMailer activity!\n\n";
print MAIL <<TO_END;
From Email: $In{fromemail}
From  Name: $In{name}
  To Email: $In{toemail}
  Page URL: $ENV{HTTP_REFERER}
TO_END
close MAIL;
$In{redirect} ? (print "Location: $In{redirect}\n\n") : (print "Location: $ENV{HTTP_REFERER}\n\n");
exit;

sub ErrorHTML
{
	my @ta = @_;
	print "Content-type: text/html\n\n";
	print '<html><head><title>Error!</title></head><body><h4>Error!</h4>';
	for (@ta) { print "\n<p>$_"; }
	print '
<p>Please click your browser\'s &quot;back&quot; button to try again. 
Thank you!
</body></html>
';
	exit;
} # sub ErrorHTML

sub ParseFormData
{
	my @pairs;
	if ($ENV{'REQUEST_METHOD'} eq 'GET')
	{ @pairs = split(/&/, $ENV{'QUERY_STRING'}); }
	elsif ($ENV{'REQUEST_METHOD'} eq 'POST')
	{
		my $buffer;
		read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
		@pairs = split(/&/, $buffer);
	}
	else { &ErrorHTML('The form\'s method must be POST or GET (all caps)'); }
	for (@pairs)
	{
		my ($name,$value) = split(/=/,$_);
		$name =~ tr/+/ /;
		$value =~ tr/+/ /;
		$name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C",hex($1))/eg;
		$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C",hex($1))/eg;
		$In{$name} = $value;
	}
} # sub ParseFormData

sub ValidEmail
{
	if($_[0] =~ /(@.*@)|(\.\.)|(@\.)|(\.@)|(^\.)/) { return 0; }
	if($_[0] !~ /^.+\@(\[?)[a-zA-Z0-9\-\.]+\.([a-zA-Z]{2,3}|[0-9]{1,3})(\]?)$/) { return 0; }
	return 1;
} # sub ValidEmail

sub StripWhiteSpaceFrontEnd     {my $s=shift @_; $s =~ s/\A\s+//m;                  return $s;}
sub StripWhiteSpaceBackEnd      {my $s=shift @_; $s =~ s/\s+\Z//m;                  return $s;}
sub StripWhiteSpaceFrontAndBack {my $s=shift @_; $s =~ s/\A\s+//m; $s =~ s/\s+\Z//m;return $s;}
sub StripAllWhiteSpace          {my $s=shift @_; $s =~ s/\s+//gm;                   return $s;}
sub ReplaceConsecutiveWhiteSpace{my $s=shift @_; $s =~ s/\s\s+/ /gm;                return $s;}

__END__
